/'
  <Slightly modified copy of the zlib license>
 
  ui_button.bi -- Interface to button widget

  Copyright (C) 2008 Daniel Cousley

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  Daniel Cousley
'/
#Ifndef UI_BUTTON_BI_INCLUDED
#Define UI_BUTTON_BI_INCLUDED

#include "ui_common.bi"

Type t_uiButton_ As t_uiButton
Type t_click_CB As Sub(ByRef self As t_uiButton_, uData As Any Ptr)

Type t_uiButton
	Private:
		_surface As Any Ptr
		_x As Integer
		_y As Integer
		_w As Integer
		_h As Integer
		_cw As Integer
		_ch As integer
		
		_colors(0 To 7) As UInteger
		
		_needsRedraw As Integer
		_needsResize As Integer
		_mState As integer
		_txt As String
		_cbData As Any Ptr
		_clicked As integer
		_clickCB As t_click_CB
		
		Declare Sub _redraw()
		Declare Sub _resize()
		Declare Sub _isClicked()
		
	Public:
		
		Declare Property xPos(newX As Integer)
		Declare Property xPos() As integer

		Declare Property yPos(newY As Integer)
		Declare Property yPos() As integer

		Declare Property wdth(newW As Integer)
		Declare Property wdth() As integer

		Declare Property height(newH As Integer)
		Declare Property height() As integer

		Declare Property text(newText As string)
		Declare Property text() As String

		Declare Property callback(newCB As t_click_CB) 
		Declare Property callback() As t_click_CB

		Declare Property callbackData(newData As Any ptr) 
		Declare Property callbackData() As Any ptr
		 
		Declare Sub render()
		Declare Sub poll()
		
		Declare Sub setColor(cElement As UInteger, newCol As UInteger)
		
		Declare Constructor()
		Declare Destructor()

End Type

#endif 